Imports System.Runtime.InteropServices
Imports System.ComponentModel

Public Class CheckPerm
    Implements IDisposable

    'typedef struct _TRUSTEE {
    '  PTRUSTEE pMultipleTrustee;
    '  MULTIPLE_TRUSTEE_OPERATION MultipleTrusteeOperation;
    '  TRUSTEE_FORM TrusteeForm;
    '  TRUSTEE_TYPE TrusteeType;
    '  LPTSTR ptstrName;
    '} TRUSTEE, *PTRUSTEE;
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto, Pack:=4)> _
    Private Structure TRUSTEE
        Dim pMultipleTrustee As IntPtr
        Dim MultipleTrusteeOperation As Integer
        Dim TrusteeForm As Integer
        Dim TrusteeType As Integer
        Dim ptstrName As IntPtr
    End Structure

    'typedef enum _SE_OBJECT_TYPE {
    '  SE_UNKNOWN_OBJECT_TYPE = 0,
    '  SE_FILE_OBJECT,
    '  SE_SERVICE,
    '  SE_PRINTER,
    '  SE_REGISTRY_KEY,
    '  SE_LMSHARE,
    '  SE_KERNEL_OBJECT,
    '  SE_WINDOW_OBJECT,
    '  SE_DS_OBJECT,
    '  SE_DS_OBJECT_ALL,
    '  SE_PROVIDER_DEFINED_OBJECT,
    '  SE_WMIGUID_OBJECT,
    '  SE_REGISTRY_WOW64_32
    '} SE_OBJECT_TYPE;
    Private Enum SE_OBJECT_TYPE As Integer
        SE_UNKNOWN_OBJECT_TYPE = 0
        SE_FILE_OBJECT
        SE_SERVICE
        SE_PRINTER
        SE_REGISTRY_KEY
        SE_LMSHARE
        SE_KERNEL_OBJECT
        SE_WINDOW_OBJECT
        SE_DS_OBJECT
        SE_DS_OBJECT_ALL
        SE_PROVIDER_DEFINED_OBJECT
        SE_WMIGUID_OBJECT
        SE_REGISTRY_WOW64_32
    End Enum

    Private Enum SECURITY_INFORMATION As Integer
        OWNER_SECURITY_INFORMATION = 1
        GROUP_SECURITY_INFORMATION = 2
        DACL_SECURITY_INFORMATION = 4
        SACL_SECURITY_INFORMATION = 8
        PROTECTED_SACL_SECURITY_INFORMATION = 16
        PROTECTED_DACL_SECURITY_INFORMATION = 32
        UNPROTECTED_SACL_SECURITY_INFORMATION = 64
        UNPROTECTED_DACL_SECURITY_INFORMATION = 128
    End Enum

    'VOID BuildTrusteeWithSid(
    '  PTRUSTEE pTrustee,
    '  PSID pSid
    ');
    Private Declare Auto Sub BuildTrusteeWithSid Lib "advapi32.dll" ( _
        ByVal pTrustee As IntPtr, _
        ByVal pSid As IntPtr _
    )

    'DWORD GetNamedSecurityInfo(
    '  LPTSTR pObjectName,
    '  SE_OBJECT_TYPE ObjectType,
    '  SECURITY_INFORMATION SecurityInfo,
    '  PSID* ppsidOwner,
    '  PSID* ppsidGroup,
    '  PACL* ppDacl,
    '  PACL* ppSacl,
    '  PSECURITY_DESCRIPTOR* ppSecurityDescriptor
    ');
    Private Declare Auto Function GetNamedSecurityInfo Lib "advapi32.dll" ( _
        ByVal pObjectName As String, _
        ByVal ObjectType As SE_OBJECT_TYPE, _
        ByVal SecurityInfo As SECURITY_INFORMATION, _
        ByRef ppsidOwner As IntPtr, _
        ByRef ppsidGroup As IntPtr, _
        ByRef ppDacl As IntPtr, _
        ByRef ppSacl As IntPtr, _
        ByRef ppSecurityDescriptor As IntPtr _
    ) As Integer

    'DWORD GetEffectiveRightsFromAcl(
    '  PACL pacl,
    '  PTRUSTEE pTrustee,
    '  PACCESS_MASK pAccessRights
    ');
    Private Declare Auto Function GetEffectiveRightsFromAcl Lib "advapi32.dll" ( _
        ByVal pacl As IntPtr, _
        ByVal pTrustee As IntPtr, _
        ByRef pAccessRights As Integer _
    ) As Integer

    'BOOL LookupAccountName(
    '  LPCTSTR lpSystemName,
    '  LPCTSTR lpAccountName,
    '  PSID Sid,
    '  LPDWORD cbSid,
    '  LPTSTR ReferencedDomainName,
    '  LPDWORD cchReferencedDomainName,
    '  PSID_NAME_USE peUse
    ');
    Private Declare Auto Function LookupAccountName Lib "advapi32.dll" ( _
        ByVal lpSystemName As String, _
        ByVal lpAccountName As String, _
        ByVal Sid As IntPtr, _
        ByRef cbSid As Integer, _
        ByVal lpReferenceDomainName As String, _
        ByRef cchReferencedDomainName As Integer, _
        ByRef peUse As Integer _
    ) As Boolean

    Private _UserName As String
    Private _Path As String
    Private _AccessMask As Integer
    Private _ErrorNum As Integer
    Private _ErrorMsg As String
    Private pTrustee, pSID As IntPtr

    Public Enum FileAccessType As Integer
        DELETE = &H10000
        READ_CONTROL = &H20000
        WRITE_DAC = &H40000
        WRITE_OWNER = &H80000
        SYNCHRONIZE = &H100000
        STANDARD_RIGHTS_REQUIRED = &HF0000
        STANDARD_RIGHTS_READ = READ_CONTROL
        STANDARD_RIGHTS_WRITE = READ_CONTROL
        STANDARD_RIGHTS_EXECUTE = READ_CONTROL
        STANDARD_RIGHTS_ALL = &H1F0000
        SPECIFIC_RIGHTS_ALL = &HFFFF
        ACCESS_SYSTEM_SECURITY = &H1000000
        MAXIMUM_ALLOWED = &H2000000
        'GENERIC_READ = &H80000000
        'GENERIC_WRITE = &H40000000
        'GENERIC_EXECUTE = &H20000000
        'GENERIC_ALL = &H10000000
        FILE_READ_DATA = &H1
        FILE_WRITE_DATA = &H2
        FILE_APPEND_DATA = &H4
        FILE_READ_EA = &H8
        FILE_WRITE_EA = &H10
        FILE_EXECUTE = &H20
        FILE_READ_ATTRIBUTES = &H80
        FILE_WRITE_ATTRIBUTES = &H100
        FILE_ALL_ACCESS = STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &H1FF
        FILE_GENERIC_READ = STANDARD_RIGHTS_READ Or FILE_READ_DATA Or FILE_READ_ATTRIBUTES Or FILE_READ_EA Or SYNCHRONIZE
        FILE_GENERIC_WRITE = STANDARD_RIGHTS_WRITE Or FILE_WRITE_DATA Or FILE_WRITE_ATTRIBUTES Or FILE_WRITE_EA Or FILE_APPEND_DATA Or SYNCHRONIZE
        FILE_GENERIC_EXECUTE = STANDARD_RIGHTS_EXECUTE Or FILE_READ_ATTRIBUTES Or FILE_EXECUTE Or SYNCHRONIZE
    End Enum

    Public Sub New()
        UserName = Environment.UserDomainName & "\" & Environment.UserName
    End Sub

    Public Property UserName() As String
        Get
            Return _UserName
        End Get
        Set(ByVal Value As String)
            Dim Domain As String
            Dim lenDomain, lenSid, peUse, LastError As Integer
            Dim Win32Error As Win32Exception
            Dim t As TRUSTEE

            _UserName = Value

            ' do a "dry run" to get the size of the SID and Domain string
            LookupAccountName(Nothing, _UserName, Nothing, lenSid, Nothing, lenDomain, peUse)
            Domain = Space(lenDomain)
            pSID = Marshal.AllocHGlobal(lenSid)

            ' do it again, for real this time
            If LookupAccountName(Nothing, _UserName, pSID, lenSid, Domain, lenDomain, peUse) = False Then
                LastError = Marshal.GetLastWin32Error()
                Win32Error = New Win32Exception(LastError)
                Throw New Exception(Win32Error.Message)
            End If

            ' Build a trustee
            pTrustee = Marshal.AllocHGlobal(Marshal.SizeOf(t))
            BuildTrusteeWithSid(pTrustee, pSID)
        End Set
    End Property

    Public Property Path() As String
        Get
            Return _Path
        End Get
        Set(ByVal Value As String)
            _Path = Value
        End Set
    End Property

    Public Property AccessMask() As Integer
        Get
            Return _AccessMask
        End Get
        Set(ByVal Value As Integer)
            _AccessMask = Value
        End Set
    End Property

    Public ReadOnly Property ErrorNum() As Integer
        Get
            Return _ErrorNum
        End Get
    End Property

    Public ReadOnly Property ErrorMsg() As String
        Get
            Return _ErrorMsg
        End Get
    End Property

    Public Function HasAccess() As Boolean
        Dim pDACL, pSD As IntPtr
        Dim Mask, ret As Integer
        Dim Win32Error As Win32Exception

        ' Some quick sanity checks...
        If _Path = "" Then
            Throw New Exception("Missing Path information")
        End If
        If _AccessMask = 0 Then
            Throw New Exception("Missing AccessMask information")
        End If
        _ErrorNum = 0
        _ErrorMsg = ""

        ' Get the DACL from the file
        ret = GetNamedSecurityInfo(_Path, SE_OBJECT_TYPE.SE_FILE_OBJECT, SECURITY_INFORMATION.DACL_SECURITY_INFORMATION, Nothing, Nothing, pDACL, Nothing, pSD)
        If ret <> 0 Then
            _ErrorNum = ret
            Win32Error = New Win32Exception(_ErrorNum)
            _ErrorMsg = Win32Error.Message
            Return False
        End If

        ' Get the Access Mask using the supplied user account
        ret = GetEffectiveRightsFromAcl(pDACL, pTrustee, Mask)
        If ret <> 0 Then
            _ErrorNum = ret
            Win32Error = New Win32Exception(_ErrorNum)
            _ErrorMsg = Win32Error.Message
            Marshal.FreeHGlobal(pSD)
            Return False
        End If

        Marshal.FreeHGlobal(pSD)

        ' Let's see if we've got a match!
        If (_AccessMask And Mask) = _AccessMask Then
            Return True
        Else
            _ErrorNum = 5
            _ErrorMsg = "Permission Denied"
            Return False
        End If
    End Function

    Public Overloads Sub Dispose() Implements IDisposable.Dispose
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub

    Protected Overloads Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            ' nothing comes to mind...
        End If
        If pSID.ToInt32 <> 0 Then
            Marshal.FreeHGlobal(pSID)
        End If
        If pTrustee.ToInt32 <> 0 Then
            Marshal.FreeHGlobal(pTrustee)
        End If
    End Sub

    Protected Overrides Sub Finalize()
        Dispose(False)
    End Sub
End Class
